//this is the normal stuff, get over to the Utilities.js for a message from me :)
//happy reading
//made by https://gildedbedrock.com
import { world, system } from '@minecraft/server';
import Utilities from "./Utilities.js";
var tick = 0;
// World Tick Function
system.runInterval(() => {
    // Run hunt tick every tick
    Utilities.huntTick(tick);
    tick++;
}, 1);


world.events.beforeChat.subscribe(async (eventData) => {
    const player = eventData.sender;
    let message = eventData.message.toLocaleLowerCase();
    switch (message) {
        case '!help':
            player.sendMessage("§g§n§l§n ~ Help Guide ~ §r" + '\n' + "§2!add§r to add yourself as a tracking beacon" + '\n' + "§4!remove§r to remove your beacon" + "\n" + "§5!track§r to give yourself a tracker compass");
            eventData.cancel = true;
            break;
        case '!add':
            if (Utilities.isOnlineBeacon(player)) {
                player.sendMessage("§7§oYou already have a tracking beacon§r" + '\n' + "§7§oTo stop being tracked, run §r§4!remove§r§7§o to remove your beacon");
                eventData.cancel = true;
                break;
            } else {
                Utilities.addBeacon(player);
                world.sendMessage("§2§l" + Utilities.bugFreeName(player) + " is being tracked!");
                player.sendMessage("§gYou are now being tracked§r" + " - " + "§4!remove§r to remove your tracking beacon");
                eventData.cancel = true;
                break;
            }
        case '!remove':
            if (Utilities.isOnlineBeacon(player)) {
                Utilities.removeBeacon(player);
                world.sendMessage("§4§l" + Utilities.bugFreeName(player) + " is no longer being tracked");
                player.sendMessage("§gYour tracking beacon was removed§r" + " - " + "To become a tracking beacon again, run §2!add§r");
                eventData.cancel = true;
                break;
            } else {
                player.sendMessage("§7§oYou already are not a tracking beacon§r" + '\n' + "§7§oTo become a tracking beacon, run §r§2!add§r");
                eventData.cancel = true;
                break;
            }
        case '!track':
            if (Utilities.hasTracker(player)) {
                player.sendMessage("§7§oYou already have a tracker");
                eventData.cancel = true;
            } else {
                player.runCommandAsync("give @s hunt:tracker1");
                player.sendMessage("§7§oYou have been given a tracker");
                eventData.cancel = true;
            }
            break;
        case '!hunt':
            Utilities.huntWorldIntroWelcome();
            eventData.cancel = true;
            break;
        case '!huntbug':
            for (const player of world.getPlayers()) {
                world.sendMessage("-------------Bug---Testing-----------------");
                world.sendMessage("BugFreeName:   "+Utilities.bugFreeName(player));
                world.sendMessage("RegularName:   "+player.name);
                world.sendMessage("PlayerScoreId:   "+player.scoreboard.id.toString());
                world.sendMessage("PlayerScoreDisplay:   "+player.scoreboard.displayName);
            }
            
            break;
        default: break;
    }
});

world.events.beforeItemUse.subscribe(event => {
    if (event.item.typeId.includes("hunt:tracker")) {
        Utilities.trackerClick(event.source);
    };
});